<?php
/*
	Plugin Name: Cross-Promotion Content Recommendations by Engageya
	Plugin URI: http://www.Engageya.com/
	Description: Displays recommendations to your blog and other blogs, at the foot of each of your posts - for enhanced user retention as well as new engaged traffic, for free
	Version: 1.0
	Author: Tal Gerbi
*/

$engageya_params = "";
$engageya_dbnurls = array();
$engageya_dbnanchors = array();
$engageya_already_shown = false;

function engageya_need_to_place_widget($content)
{
	return (is_single() || engageya_show_recommendations($content)) && !is_feed() && !is_page() && (is_single() || !get_option('show_grazeit_only_in_single_posts'));
}

function engageya_add_widget($content) 
{
	global $engageya_already_shown;
    if (engageya_need_to_place_widget($content) && (!is_single() || !$engageya_already_shown))
	{
		global $post, $engageya_dbnurls , $engageya_dbnanchors;
		
		$engageya_already_shown = true;
		$linkToPost = get_permalink($post->ID);
		array_push($engageya_dbnurls , $linkToPost);
		array_push($engageya_dbnanchors, "spark_static_widget_" . $post->ID);
		$content .= '<div id="spark_static_widget_'. $post->ID .'"></div>';
    }
    return $content;
}


//add an option menu to "Settings"
function engageya_insert_options_page()
{
    add_options_page('Engageya', 'Engageya', 9, 'options-engageya', 'show_engageya_options_page');
}

//display the options page
function show_engageya_options_page()
{
    if (isset($_POST['show_grazeit_only_in_single_posts'])) {
		if($_POST['show_grazeit_only_in_single_posts'] == "single")
			$show_grazeit_only_in_single_posts = true;
		else
			$show_grazeit_only_in_single_posts = false;
        update_option('show_grazeit_only_in_single_posts', $show_grazeit_only_in_single_posts);
        echo '<div class="updated fade"><p style="color: red;">Engageya settings were updated successfully</p></div>';
    }
    $show_grazeit_only_in_single_posts = get_option('show_grazeit_only_in_single_posts');
    ?>
    <h2 style="text-align: center;">Engageya Settings</h2>
    <form action="?page=options-engageya" method="POST">
		<h4>Display</h4>
		<div style="margin-left: 30px">
			<input type="radio" name="show_grazeit_only_in_single_posts" value="single" id="show_grazeit_only_in_single_posts_false" <?php if ($show_grazeit_only_in_single_posts) { echo 'checked="checked"'; } ?>>
				Show Recommendations by Engageya <span style="font-weight:bold;">only in pages with a single post</span> <br />
			<input type="radio" name="show_grazeit_only_in_single_posts" value="multi" id="show_grazeit_only_in_single_posts" <?php if (!$show_grazeit_only_in_single_posts) { echo 'checked="checked"'; } ?>>
				Show Recommendations by Engageya <span style="font-weight:bold;">in pages with multiple posts, too</span>
		</div>
		
		<p>
			<input value="Save Changes" type="submit">
		</p>
    </form>
<?php
}

function engageya_add_widget_script($content)
{
	//do not write tag on homepages, or pages with no dbnanchors
	global $engageya_already_shown;
	if (!$engageya_already_shown) {
		return $content;
	}

	global $engageya_dbnurls , $engageya_dbnanchors;
	
	$grazeit_script = '<script type="text/javascript" id="wordpress_grazit_script">		
		var dbnurls = [];
		var dbnanchors = [];
';
	for($i = 0; $i < sizeof($engageya_dbnurls ); $i++)
		$grazeit_script .= "		dbnurls.push('" . $engageya_dbnurls [$i] . "');\n";
	for($i = 0; $i < sizeof($engageya_dbnanchors); $i++)
		$grazeit_script .= "		dbnanchors.push('" . $engageya_dbnanchors[$i] . "');\n";
	$grazeit_script .= '		var script = document.createElement("script");
		script.setAttribute("src", "http://widget.grazeit.com/sprk.js");
		script.setAttribute("type", "text/javascript");
		script.setAttribute("id", "grazit_script");
		document.getElementById("wordpress_grazit_script").parentNode.appendChild(script);
</script>
';
	echo get_option("engageya_params");
	echo $grazeit_script;
}

function engageya_get_url_contents($url){
	$engageya_crl = curl_init();
	$engageya_timeout = 5;
	curl_setopt ($engageya_crl, CURLOPT_URL,$url);
	curl_setopt ($engageya_crl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($engageya_crl, CURLOPT_CONNECTTIMEOUT, $engageya_timeout);
	$http_response = curl_exec($engageya_crl);
	curl_close($engageya_crl);
	return $http_response;
}

function engageya_initialize_widget() {

	global $engageya_params;
	if(!get_option("engageya_params"))
	{
		if($engageya_params == ""){
			$engageya_params = engageya_get_url_contents("http://www.engageya.com/wordpress/register/?ver=1&url=" . urlencode (get_bloginfo('wpurl')));
		}
		update_option("engageya_params", $engageya_params);
	}
}

include "templates.php";
engageya_add_all_templates();

add_filter('the_content', 'engageya_add_widget');
add_action('init', 'engageya_initialize_widget');
add_action('wp_footer', 'engageya_add_widget_script');
add_action('admin_menu',  'engageya_insert_options_page');